---
title: RTCIceCandidatePairStats.state
slug: Web/API/RTCIceCandidatePairStats/state
tags:
  - API
  - Candidate
  - CandidatePair
  - Check List
  - ICE
  - Pair
  - Property
  - RTCIceCandidatePair
  - RTCIceCandidatePairStats
  - Reference
  - Statistics
  - Stats
  - WebRTC
  - WebRTC API
  - state
---
<p>{{APIRef("WebRTC")}}</p>

<p><span class="seoSummary">The <code><strong>state</strong></code> property in an {{domxref("RTCIceCandidatePairStats")}} object indicates the state of the check list of which the candidate pair is a member.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>state</em> = <em>rtcIceCandidatePairStats</em>.state;</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMString")}} whose value is one of those found in the {{domxref("RTCStatsIceCandidatePairState")}} enumerated type.</p>

<h2 id="ICE_check_lists">ICE check lists</h2>

<p>During ICE negotiation, the ICE layer builds up a <strong>check list</strong>, which is a list of potential pairings of ICE candidates. Each pair has a state, whose value is represented by <code>RTCStatsIceCandidatePairState</code>.</p>

<p><img alt="A diagram showing how ICE candidate pairs change state as the check list is analyed" src="https://mdn.mozillademos.org/files/16570/ice-check-list-states.svg" style="height: 321px; width: 561px;"></p>

<p>When a candidate pair is added to the check list, it begins in the <code>frozen</code> state. As soon as there are no checks ongoing which block the pair from being analyzed, it is unfrozen and moves into the <code>waiting</code> state. This may happen immediately upon being added to the check list.</p>

<p>Each time a candidate pair is done being checked, the next-highest priority candidate pair remaining on the check list moves from the <code>waiting</code> state to the <code>in-progress</code> state, and its check begins. If the check fails for any reason, the pair moves into its final state, <code>failed</code>. If the check succeeds, the pair ends up in the <code>succeeded</code> state.</p>

<p>The ICE check list state for any given pair of ICE candidates can be found in the corresponding the <code>state</code> property.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('WebRTC Statistics Identifiers', '#dom-rtcicecandidatepairstats-state', 'RTCIceCandidatePairStats.state') }}</td>
   <td>{{ Spec2('WebRTC Statistics Identifiers') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCIceCandidatePairStats.state")}}</p>
